#include "testlib.h"
#include <iostream>
#include <sstream>

using namespace std;

int s2i(const string &s)
{
    stringstream ss;
    ss << s;
    int x;
    ss >> x;
    return x;
}

int m;
int d, a1, b1, a2, b2;

void shuffle_input()
{
    if (rnd.next(2)) {
        swap(b1, b2);
        swap(a1, a2);
    }
    if (rnd.next(2)) {
        swap(a1, b1);
        swap(a2, b2);
    }
}

int main(int argc, char *argv[])
{
    registerGen(argc, argv);

    m = s2i(argv[1]);
    int q = s2i(argv[2]);

    if (q == 1) {
        d = -1;
        a1 = m - 1, b1 = 0, a2 = 0, b2 = m - 1;
    } else if (q == 2) {
        d = 1;
        a1 = b1 = 0, a2 = m - 2, b2 = m - 1;
    } else if (q == 3) {
        d = 1;
        a1 = m - 1, b1 = rnd.next(m), a2 = 0, b2 = b1;
    } else if (q == 4) {
        d = 1;
        a1 = m - 1, b1 = 0, a2 = 0, b2 = m - 1;
    }

    shuffle_input();

    cout << d << endl;
    cout << a1 + 1 << " " << b1 + 1 << " " << a2 + 1 << " " << b2 + 1 << endl;

    return 0;
}
