#include <iostream>
#include <fstream>

using namespace std;

ifstream in("posts.in");
ofstream out("posts.out");

int d, a1, a2, b1, b2;

bool check(int n)
{
    int b_src = (a1 - d * b1 + n) % n;
    return (b_src + d * b2 + n) % n == a2;
}

int main()
{
    in >> d >> a1 >> b1 >> a2 >> b2;
    --a1, --b1, --a2, --b2;
    int low = max(max(a1, b1), max(a2, b2)) + 1;
    for (int n = low; n <= 2 * low + 10; ++n) {
        if (check(n)) {
            out << n << endl;
            return 0;
        }
    }
    out << -1 << endl;

    return 0;
}
