#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);

string gentue(int n, char a, char b) {
	if (n == 1) {
		string res;
		res += a;
		res += b;
		return res;
	}
	string tue = gentue(n - 1, a, b);
	string res = tue;
	for (int i = 0; i < (int) tue.size(); i++)
		if (tue[i] == a)
			tue[i] = b;
		else
			tue[i] = a;
	return res + tue;
}

int main(int argc, char ** argv) {	
	registerGen(argc, argv);
	if (argc != 5) {
		cerr << "Usage: log n, int k, char 1, char 2" << endl;
		
		return 1;
	}

	int n = atoi(argv[1]);
	int k = atoi(argv[2]);
	char c1 = argv[3][0];
	char c2 = argv[4][0];
	
	cout << (1 << n) << ' ' << k << endl;
	cout << gentue(n, c1, c2) << endl;

	return 0;
}