#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);
const int bsize = 400 * 1000;
int n, k, d, len;
char buf[bsize];
int magic = 1000;

int nod(int a, int b) {
	if (b == 0)
		return a;
	else
		return nod(b, a % b);
}

int cmp(int p1, int p2) {
	for (int i = 0; i < min(magic, len); i++) {
		if (buf[p1] != buf[p2])
			return (buf[p1] > buf[p2]) * 2 - 1;
	   	p1 += k;
	   	if (p1 >= n)
	   		p1 -= n;
	   	p2 += k;
	   	if (p2 >= n)
	   		p2 -= n;
	}

	return 0;
}

int main() {
	double tm = clock();

    freopen("games.in", "r", stdin);
    freopen("games.out", "w", stdout);
    
    scanf("%d%d", &n, &k);
    scanf("%s", buf);
    k %= n;
    k = (k + n) % n;
    d = nod(n, k);
    len = n / d;
    vector <int> ans;
magic = min(1000, len);
    while ((clock() - tm) / CLOCKS_PER_SEC * 3 < 2.0 && magic <= len) {
	    magic *= 2;
	    ans.clear();
	    ans.pb(0);
    	int b = 0;
    	for (int i = 1; i < n; i++) {
    		int loc = cmp(b, i);
    		if (loc == 0) {
    			ans.pb(i);
    		}
    		if (loc > 0) {
    			b = i;
    			ans.clear();
    			ans.pb(i);
	    	}
    	}
    }
    if (ans.size() == 1u)
    	printf("Finite\n");
    else
    	printf("Infinite\n");
  	for (int i = 0; i < (int) ans.size(); i++)
  		printf("%d%c", ans[i] + 1, " \n"[i == (int) ans.size() - 1]);

    return 0;
}