#include "testlib.h"
using namespace std;

const int N = (int) 1e5;
int x[N], y[N], cx[N], cy[N], h, c;

int check(InStream& in) {
	int res = in.readInt(), cur = 0, num = in.readInt(1, h) - 1;
	for (int i = 0; i < c; ++i)
		cur = max(cur, abs(x[num] - cx[i]) + abs(y[num] - cy[i]));
	if (cur != res)
		in.quitf(_wa, "answer is not correct: promised %d, but actual value is %d\n", res, cur);
	return cur;
}

int main(int argc, char ** argv) {
	registerTestlibCmd(argc, argv);
	int n = inf.readInt(), m = inf.readInt();
	c = inf.readInt();
	for (int i = 0; i < c; ++i)
		cx[i] = inf.readInt(), cy[i] = inf.readInt();
	h = inf.readInt();
	for (int i = 0; i < h; ++i)
		x[i] = inf.readInt(), y[i] = inf.readInt();
	int value = check(ouf), optimal = check(ans);
	if (value != optimal)	
		((value < optimal) ? ans : ouf).quitf(_wa, "answer is not optimal: contestant has %d, jury has %d\n", value, optimal);
	quitf(_ok, "answer is %d\n", optimal);
}