if [ "$1" = "" ]; then
    read
fi
if [ "$2" = "" ]; then
    read
fi
if [ ! -f "$1" ]; then
    read
fi
echo "Running validator"
wine files/towin.exe "$1" | wine files/validate.exe
if [ "$?" -ne "0" ]; then
    read
fi
cp $1 grid.in
echo "Running solution grid_mp_n.cpp"
wine solutions/grid_mp_n.exe
if [ "$?" -ne "0" ]; then
    echo "Solution returned non-zero exit code"
    read
fi
rm -f grid.in
if [ ! -f "grid.out" ]; then
    echo "Solution didn't produced output [grid.out]"
    read
fi
mv "grid.out" "$2"
echo "Running checker"
wine check.exe $1 $2 $2
if [ "$?" -ne "0" ] && [ "$?" -ne "7" ]; then
    echo "Checker exit code is not equal to 0 and 7"
    read
fi
