#include "testlib.h"

using namespace std;

const int N = 1e6;

int n;
string s;

int a[N];
bool u[N];

int main(int argc, char * argv[]){
    registerTestlibCmd(argc, argv);
		n = inf.readInt();
		s = n > 1 ? inf.readWord() : "";
		memset(u, 0, sizeof(bool) * n);
		for (int j = 0; j < n; j++){
			a[j] = ouf.readInt(1, n);
			if (u[a[j] - 1])
				quitf(_pe, "Permutation expected: %d found at least twice.", a[j]);
			u[a[j] - 1] = true;
		}
		for (int j = 0; j < n - 1; j++)
			if (s[j] == '<' && a[j] > a[j + 1])
				quitf(_wa, "Requirement A_%d < A_%d does not hold: %d > %d\n", j + 1, j + 2, a[j], a[j + 1]);
			else if (s[j] == '>' && a[j] < a[j + 1])
				quitf(_wa, "Requirement A_%d > A_%d does not hold: %d < %d\n", j + 1, j + 2, a[j], a[j + 1]);
	quitf(_ok, "Ok.");
	return 0;
}
