#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>

using namespace std;

const int N = 1e6 + 10;

int n;
char s[N];
int g[N][2], gln[N];
bool u[N];

int cTime[N];
int curTime = 0;

void topSort(int v){
	if (u[v])
		return ;
	u[v] = true;
	int size = gln[v];
	for (int i = 0; i < size; i++)
		topSort(g[v][i]);
	cTime[v] = ++curTime;
}

void solve(){
	assert(scanf("%d%s", &n, s));
	memset(gln, 0, sizeof(int) * n);
	for (int i = 0; i < n - 1; i++){
		if (s[i] == '<')
			g[i + 1][gln[i + 1]++] = i;
		else if (s[i] == '>')
			g[i][gln[i]++] = i + 1;
		else
			assert(false);
	}
	memset(u, 0, sizeof(bool) * n);
	curTime = 0;
	for (int i = 0; i < n; i++)
		topSort(i);
	for (int i = 0; i < n; i++)
		printf("%d%c", cTime[i], " \n"[i == n - 1]);
}

int main(){
        freopen("tourism.in", "r", stdin);
        freopen("tourism.out", "w", stdout);
	//int t; assert(scanf("%d", &t));
	//for (int i = 0; i < t; i++)
		solve();
	return 0;
}