#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <deque>

#define mp make_pair

using namespace std;

const int N = 2e6 + 10;

int n;
char s[N];
int g[N][2], gln[N];
bool u[N];

int cTime[N], cnt[N];

deque<int> q;

void solve(){
	assert(scanf("%d%s", &n, s));
	memset(gln, 0, sizeof(int) * n);
	for (int i = 0; i < n - 1; i++){
		if (s[i] == '<')
			g[i + 1][gln[i + 1]++] = i;
		else if (s[i] == '>')
			g[i][gln[i]++] = i + 1;
		else
			assert(false);
	}
	memset(cnt, 0, sizeof(int) * n);
	for (int i = 0; i < n; i++){
		int size = gln[i];
		for (int j = 0; j < size; j++)
			++cnt[g[i][j]];
	}
	int curTime = n;
	for (int i = 0; i < n; i++)
		if (cnt[i] == 0)
			q.push_back(i);
	for (int i = 0; i < n; i++){
		assert(!q.empty());
		int index = q.front();
		q.pop_front();
		assert(index < n);
		cnt[index] = 1e9;
		cTime[index] = curTime--;
		int size = gln[index];
		for (int j = 0; j < size; j++){
			--cnt[g[index][j]];
			if (cnt[g[index][j]] == 0)
				q.push_back(g[index][j]);
		}	
	}
	for (int i = 0; i < n; i++)
		printf("%d%c", cTime[i], " \n"[i == n - 1]);
}

int main(){
        freopen("signs.in", "r", stdin);
        freopen("signs.out", "w", stdout);
//	int t; assert(scanf("%d", &t));
//	for (int i = 0; i < t; i++)
		solve();
	return 0;
}