import random
from sys import argv, stderr

N = int(argv[1])
MAX_M = int(argv[2])
SEED = int(argv[-1])

random.seed(SEED)

if 8*N > MAX_M:
#    print("N is too little", file=stderr)
    exit(1)

V = []

for i in range(1, 4*N+1):
    V.append([i, max(0, i-4)])

for i in range(N-1):
    V.append([4*i+1, 4*i+2])
    V.append([4*i+2, 4*i+3])
    V.append([4*i+3, 4*i+4])
    V.append([4*i+4, 4*i+1])

N = 4*N + 1

random.shuffle(V)

l = list(range(N))
random.shuffle(l)
for i in range(len(V)):
    V[i][0] = l[V[i][0]]+1
    V[i][1] = l[V[i][1]]+1
    random.shuffle(V[i])

print N, len(V)
for u, v in V:
    print u, v
