#include <cstdio>
#include <algorithm>
#include <vector>
#include "testlib.h"
using namespace std;

vector<pair<int, int> > V;

int main(int argc, char* argv[])
{
    registerGen(argc, argv);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int ref = atoi(argv[1]);
    int rev = atoi(argv[2]);
    vector<pair<int, int> > H;
    if (rev)
        swap(n, m);
    for (int j = 1; j <= m; j++)
        H.push_back(make_pair(1, j));
    for (int j = m; j >= 1; j--)
        if (j & 1)
            for (int i = n; i >= 2; i--)
                H.push_back(make_pair(i, j));
        else
            for (int i = 2; i <= n; i++)
                H.push_back(make_pair(i, j));

    int pt = (int)(H.size()) - 1;
    for (int it = 0; it < n * m - 3; it++)
    {
        V.push_back(H[pt]);
        pt = ((pt - (it + 4)) % H.size() + H.size()) % H.size();
    }
    if (ref)
    {
        swap(n, m);
        for (int i = 0; i < V.size(); i++)
            swap(V[i].first, V[i].second);
    }
    if (rev)
        reverse(V.begin(), V.end());
    printf("%d %d\n0\n%d\n", n, m, (int)V.size());
    for (int i = 0; i < V.size(); i++)
        printf("%d %d\n", V[i].first, V[i].second);
    
    return 0;
}
