if [ "$1" = "" ]; then
    read
fi
if [ "$2" = "" ]; then
    read
fi
if [ ! -f "$1" ]; then
    read
fi
echo "Running validator"
wine files/towin.exe "$1" | wine files/counting_trees_validate.exe
if [ "$?" -ne "0" ]; then
    read
fi
cp $1 posts.in
echo "Running solution counting-posts_ap_ok_1.py"
python solutions/counting-posts_ap_ok_1.pys2
if [ "$?" -ne "0" ]; then
    echo "Solution returned non-zero exit code"
    read
fi
rm -f posts.in
if [ ! -f "posts.out" ]; then
    echo "Solution didn't produced output [posts.out]"
    read
fi
mv "posts.out" "$2"
echo "Running checker"
wine check.exe $1 $2 $2
if [ "$?" -ne "0" ] && [ "$?" -ne "7" ]; then
    echo "Checker exit code is not equal to 0 and 7"
    read
fi
