//	#pragma comment(linker, "/STACK:60000000")
#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include "testlib.h"

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define len(x) (int((x).size()))
#ifdef LOCALD
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) {}
#endif

#ifdef __linux__
#define I64d "%lld"
#else
#define I64d "%I64d"
#endif

typedef long long int int64;
typedef long double ext;
typedef unsigned int uint;


using namespace std;

int n;


const int iinf = 2000000000;

vector<uint> vans[5];


int cards(int n, int f, int j){
	int mx = iinf;
	if (len(vans[f]) > n - 1)
		mx = vans[f][n - 1] + 1;
	return min(max(mx + j, 2), iinf);		 
}

void out(int n, int f, int j){
	printf("%d %d %d\n", n, f, cards(n, f, j));	

}


int main(int argc, char *argv[])
{
	for (int i = 0; i < 5; i++){
		vans[i].clear();
		vans[i].pb(i + 1);
		for (;int64(vans[i].back()) <= iinf / 2;)
			vans[i].pb(vans[i].back() * 2);			
	}	

	registerGen(argc, argv, 1);
	n = atoi(argv[1]);
	printf("15\n");
	for (int i = 0; i <= 4; i++)
		for (int j = -1; j <= 1; j++)
			out(n, i, j);
			
    return 0;
}
