#include <iostream> 
#include <cstdio> 
#include <cmath> 
#include <ctime> 
#include <cstdlib> 
#include <cstring> 
#include <cassert> 
#include <algorithm> 
#include <vector> 
#include <set> 
#include <string> 
 
#define pb push_back 
#define mp make_pair 
#define fs first 
#define sc second 
#define len(x) (int((x).size())) 
#ifdef LOCALD 
#define eprintf(...) fprintf(stderr, __VA_ARGS__) 
#else 
#define eprintf(...) {} 
#endif 
 
#ifdef __linux__ 
#define I64d "%lld" 
#define I64u "%llu" 
#else 
#define I64d "%I64d" 
#define I64u "%I64u" 
#endif 
 
typedef long long int int64; 
typedef long double ext; 
 
const int inf = 1000000000; 
const int mod = 1000000009; 
 
using namespace std; 
 
int n, f; 
int64 kk; 
 
 
int64 power2(int x){ 
    if (x == 0) 
        return 1; 
    else if (x & 1) 
        return (2 * power2(x - 1)); 
    else{ 
        int64 a = power2(x >> 1); 
        return a * a; 
    } 
} 
 
int tests; 
 
int main() 
{ 
    assert(freopen("solitaire.in", "rt", stdin)); 
    assert(freopen("solitaire.out", "wt", stdout)); 
    scanf("%d", &tests); 
    for (int test = 0; test < tests; test++){ 
        scanf("%d %d"I64d, &n, &f, &kk); 
        n++;
        if (n == 1){ 
				printf("NO\n");
                continue; 
        } 
        if (n - 2 >= 40){ 
            printf("YES\n"); 
            continue; 
        }     
        int64 p = power2(n - 2); 
        eprintf(I64u"\n", p); 
        p = p * (f + 1ll);         
       	printf("%s\n", p >= kk - 1 ? "YES" : "NO");     
    }     
    return 0; 
}