#include "testlib.h"
#include <iostream>

using namespace std;

vector<int> masks;

int main(int argc, char* argv[]){
    registerGen(argc, argv);
    int n = 1e6;
	int cnt;
	for (cnt = 0; cnt * (1 << cnt) < n - 1; cnt++);
	--cnt;
	cout << n << endl;
	string s = "";
	for (int i = 0; i < (1 << cnt); i++)
		masks.push_back(i);
	shuffle(masks.begin(), masks.end());
	for (int t = 0; t < (1 << cnt); t++){
		int i = masks[t];
		for (int j = 0; j < cnt; j++)
			s += (i & (1 << j)) ? ">" : "<";
	}
	while (s.size() < n - 1)
		s += rnd.next(2) ? ">" : "<";
	cout << s << endl;
	return 0;
}
