#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);
const int size = 200 * 1000;

vector <int> vertex[size];
vector <pair <int, int> > nvertex[size];
bool used[size];
bool incyc[size];
int n, m;
int nnum[size];
bool used2[size];

pair <int, int> dfs(int v, int fr) {
	if (vertex[v].size() != 2u)
		return mp(v, 1);
   	for (int i = 0; i < (int) vertex[v].size(); i++) {
   		if (vertex[v][i] != fr) {
	   		pair <int, int> pr = dfs(vertex[v][i], v);
	   		pr.sc++;

	   		return pr;
	   	}
   	}
}

void dfs2(int v, int fr) {
	used2[v] = true;
	for (int i = 0; i < (int) nvertex[v].size(); i++)
		if (used[nvertex[v][i].fs] && nvertex[v][i].fs != fr) {
			if (!used2[nvertex[v][i].fs])
				dfs2(nvertex[v][i].fs, v);
		   	return;
		}
}

int main() {
	int v, u;

    freopen("map.in", "r", stdin);
    freopen("map.out", "w", stdout);

    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; i++) {
    	scanf("%d%d", &v, &u);
    	v--, u--;
    	vertex[v].pb(u);
    	vertex[u].pb(v);
    }

    int cnt = 0;
    for (int i = 0; i < n; i++)
    	if ((int) vertex[i].size() != 2) {
    		nnum[i] = cnt++;	
    	} else {
    		nnum[i] = -1;
    	}
    for (int i = 0; i < n; i++)
    	if (nnum[i] != -1) {
    		for (int j = 0; j < (int) vertex[i].size(); j++) {
    			nvertex[nnum[i]].pb(dfs(vertex[i][j], i));
    			nvertex[nnum[i]].back().fs = nnum[nvertex[nnum[i]].back().fs];
    		}
    	}
    bool flag = true;
    int h = 0;
    for (int i = 0; i < cnt; i++)
    	if (nvertex[i].size() == 1u) {
    		h++;
    		if (used[nvertex[i][0].fs]) {
    			flag = false;
    		} else {
    			used[nvertex[i][0].fs] = true;
    			h++;
    		}
    	}
   //	cerr << flag << endl;
   
    if (h + 1 != cnt)
    	flag = false;
   //	cerr << flag << endl;
   
	for (int i = 0; i < cnt; i++)
   		if (used[i] && nvertex[i].size() != 4u)
   			flag = false;
   	int cen = -1;
   //	cerr << flag << endl;
   
	for (int i = 0; i < cnt; i++)
   		if (nvertex[i].size() > 1u && !used[i])
   			cen = i;
   //	cerr << cnt << ' ' << cen << endl;
   	if (cen == -1)
   		flag = false;
   	if (nvertex[cen].size() < 3)
   		flag = false;
   //	cerr << nvertex[cen].size() << endl;
   	if ((int) nvertex[cen].size() * 2 + 1 != cnt)
   		flag = false;
   //	cerr << flag << endl;
   	for (int i = 0; i < cnt; i++)
   		if (used[i])
   			for (int j = 0; j < (int) nvertex[i].size(); j++)
   				if (used[nvertex[i][j].fs] && nvertex[i][j].sc != 1)
   					flag = false;
   	for (int i = 0; i < cnt; i++)
   		if (used[i]) {
   			for (int j = 0; j < (int) nvertex[i].size(); j++)
   				if (used[nvertex[i][j].fs]) {
   					dfs2(nvertex[i][j].fs, i);
   					break;
   				}
   			break;
   		}
   	for (int i = 0; i < cnt; i++)
   		if (used[i] ^ used2[i])
   			flag = false;
   	if (flag)
   		cout << "YES" << endl;
   	else
   		cout << "NO" << endl;

    return 0;
}